var reqAsins         = null;
var reqItem          = null;
var gRefreshTimeout  = null;

var gUpdateInterval  = 1000 * 60 * 60; // 1 hour

var gMyScrollbar;
var gMyScrollArea;
var gDoneButton;
var gInfoButton;

var gInfoPanelAnimator;
var gInfoPanelAnimation;
var gInfoPanelVisible = false;

var gGotDate = false;
var gDOMObjs = new Object();

var categories;

// Amazon Web Services params
var AWSKey = '0NK019CD48HNEDK3PBG2';
var AWSVersion = '2006-03-08';

function createkey(key)
{
	return widget.identifier + "-" + key;
}

// Event handlers
function onshow() 
{
    if (gRefreshTimeout == null && gGotData) {
        gRefreshTimeout = setInterval(getAsins, gUpdateInterval);
    }
}

function onhide() 
{
    if (gRefreshTimeout != null) {
        clearInterval(gRefreshTimeout);
        gRefreshTimeout = null;
    }
}

function onremove()
{
	if (window.widget)
	{
		widget.setPreferenceForKey(null, createkey("preferredCategory"));
		widget.setPreferenceForKey(null, createkey("preferredBrowseNodeId"));
	}
}

// main widget setup function
function setup()
{
    gDoneButton   = new AppleGlassButton(o("doneButton"), "Done", hidePrefs);
    gInfoButton   = new AppleInfoButton(o("infoButton"), o("front"), "black", "black", showPrefs);
	gMyScrollbar  = new AppleVerticalScrollbar(o("scroller"));
    gMyScrollArea = new AppleScrollArea(o("list"));

    gMyScrollArea.addScrollbar(gMyScrollbar);

	o("version").innerHTML = "v" + version();

	populateCategoriesArray();

	var preferredCategory;
	var preferredBrowseNodeId;

	// initialise category drop-down
	if (window.widget)
	{
		preferredCategory = widget.preferenceForKey(createkey("preferredCategory"));
		preferredBrowseNodeId = widget.preferenceForKey(createkey("preferredBrowseNodeId"));
	
		widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onremove = onremove;
	}

	if (!preferredCategory || preferredCategory.length == 0)
		preferredCategory = "Books";
	o("category").value = preferredCategory;

	loadSubcategories();
	
	if (!preferredBrowseNodeId || preferredBrowseNodeId.length == 0)
		preferredBrowseNodeId = 17;
	o("subcategory").value = preferredBrowseNodeId;

	getAsins();
}

// Ajax routines for getting list of ASINs
function getAsins()
{
	var browseNodeId = o('subcategory').value;
	var category     = o('category').value;

	var subcategory  = categories[category][o('subcategory').selectedIndex][0];
	
	if (window.widget)
	{
		widget.setPreferenceForKey(o("category").value, createkey("preferredCategory"));
		widget.setPreferenceForKey(o("subcategory").value, createkey("preferredBrowseNodeId"));
	}
	
	o('category_display').innerHTML = category + ' &raquo; ' + subcategory;
	
	reqAsins = new XMLHttpRequest();
	url = 'http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=' + AWSKey + '&AssociateTag=widget-20';
	url = url + '&Operation=BrowseNodeLookup&BrowseNodeId=' + browseNodeId + '&ResponseGroup=NewReleases&Marketplace=us&Version=' + AWSVersion;
	reqAsins.onreadystatechange = processAsins;
	reqAsins.open("GET", url);
	reqAsins.send(null);
}

function processAsins()
{
	if (reqAsins.readyState == 4)
	{
		if (reqAsins.status == 200)
		{
			gGotData = true;
			list     = o('list');
			result   = '';
			
			releases = reqAsins.responseXML.getElementsByTagName('NewRelease');
			for (i = 0; i < releases.length; i++)
			{
				var asin     = releases[i].getElementsByTagName('ASIN')[0].firstChild.data;
				var title    = releases[i].getElementsByTagName('Title')[0].firstChild.data;
				var divclass = i % 2 ? 'row1' : 'row2';
				result       = result + '<div class="row ' + divclass 
				                      + '"><a href="javascript:getItemDetails(\'' 
				                      + asin + '\')">' + title + '</a></div>';
			}
			list.innerHTML = result;
			// re-draw scroll bar
			gMyScrollArea.refresh();
		}
	}
}

// Ajax routines for getting info about single ASIN 
function getItemDetails(asin)
{
	o('item_image').innerHTML  = '<img src="images/Progress.gif" />';
	o('item_extras').innerHTML = '';
	o('item_price').innerHTML  = '';
	o('item_link').innerHTML   = '';
	o('item_stars').innerHTML  = '';

	showInfoPanel();
	
	reqItem = new XMLHttpRequest();
	var url = 'http://webservices.amazon.com/onca/xml?Service=AWSECommerceService'
	          + '&AWSAccessKeyId=' + AWSKey 
	          + '&ResponseGroup=Small,Images,Reviews,OfferSummary&Operation=ItemLookup&ItemId=' + asin 
	          + '&Version=' + AWSVersion;

	reqItem.onreadystatechange = processItemDetails;
	reqItem.open("GET", url);
	reqItem.send(null);
}

function processItemDetails()
{
	if (reqItem.readyState == 4)
	{
		if (reqItem.status == 200)
		{
			var item = reqItem.responseXML.getElementsByTagName("Item")[0];
			var stars = -1;
			
			var img_w, img_h, img_url;
			var image = null;
			
			// get asin
			var asin = item.getElementsByTagName('ASIN')[0].firstChild.data;
			
			// get price
			if (item.getElementsByTagName('LowestNewPrice')[0])
			{
				price = item.getElementsByTagName('LowestNewPrice')[0].getElementsByTagName('FormattedPrice')[0].firstChild.data;
			}
			else
			{
				price = "$TBA";
			}
			
			// get image
			if (item.getElementsByTagName('MediumImage')[0])
			{
				image = item.getElementsByTagName('MediumImage')[0];
			}
			else if (item.getElementsByTagName('LargeImage')[0])
			{
				image = item.getElementsByTagName('LargeImage')[0].getElementsByTagName('URL')[0].firstChild.data;
			}
			else if (item.getElementsByTagName('SmallImage')[0])
			{
				image = item.getElementsByTagName('SmallImage')[0];
			}
			else
			{
				img_url = 'images/no_image.gif';
				img_w   = 82;
				img_h   = 82;
			}
			
			if (image)
			{
				img_url = image.getElementsByTagName('URL')[0].firstChild.data;
				img_w   = parseInt(image.getElementsByTagName('Width')[0].firstChild.data);
				img_h   = parseInt(image.getElementsByTagName('Height')[0].firstChild.data);
				
				MAX_DIM = 100;
				if (img_w > MAX_DIM || img_h > MAX_DIM)
				{
					factor = img_w > img_h ? MAX_DIM / img_w : MAX_DIM / img_h;
					img_w = parseInt(img_w * factor);
					img_h = parseInt(img_h * factor);
				}
			}
			
			// get rating
			if (item.getElementsByTagName('AverageRating')[0])
			{
				rating = item.getElementsByTagName('AverageRating')[0].firstChild.data;
				stars = '<img src="images/stars/' + Math.round(rating) + '.png" />';
			}
			else
			{
				stars = 'Not yet rated';
			}

			// get extras
			var extras = '';
			if (item.getElementsByTagName('Artist')[0])
				extras = item.getElementsByTagName('Artist')[0].firstChild.data
			else if (item.getElementsByTagName('Author')[0])
				extras = item.getElementsByTagName('Author')[0].firstChild.data
			
			o('item_image').innerHTML = '<a href="javascript:goAmazon(\'' 
										+ asin + '\');"><img border="0" src="'
										+ img_url + '" width="' + img_w + '" height="' + img_h + '"/></a>';
			o('item_extras').innerHTML = extras;
			o('item_extras').style.padding = extras ? '0px 0px 6px 0px' : '0px'
			o('item_price').innerHTML = price;
			o('item_link').innerHTML = '<a href="javascript:goAmazon(\'' + asin + '\');">See it at Amazon.com!</a>';
			o('item_stars').innerHTML = stars;
		}
		else
		{
			o('item_image').innerHTML = 'Error retrieving data from Amazon - please try again.'
		}
	}
}

// Code to slide info panel in and out of view

function toggleInfoPanel()
{
	if (gInfoPanelVisible)
		hideInfoPanel();
	else
		showInfoPanel();
}

function showInfoPanel()
{
	if (!gInfoPanelVisible)
	{
		if (window.widget) window.resizeTo(429, 291);
		
		gInfoPanelVisible = true;
		if (gInfoPanelAnimator != null) gInfoPanelAnimator.stop();
		gInfoPanelAnimator = new AppleAnimator(500,50);
		gInfoPanelAnimation = new AppleAnimation(40, 240, slideInfoPanel);
		gInfoPanelAnimator.addAnimation(gInfoPanelAnimation);
		gInfoPanelAnimator.start();
	}
}

function hideInfoPanel()
{
	if (gInfoPanelVisible)
	{
		gInfoPanelVisible = false;
		if (gInfoPanelAnimator != null) gInfoPanelAnimator.stop();
		gInfoPanelAnimator = new AppleAnimator(500,50);
		gInfoPanelAnimation = new AppleAnimation(240, 40, slideInfoPanel);	
		gInfoPanelAnimator.addAnimation(gInfoPanelAnimation);
		gInfoPanelAnimator.oncomplete = hideInfoPanelCompleted;
		gInfoPanelAnimator.start();
	}
}

function hideInfoPanelCompleted()
{
	if (window.widget) window.resizeTo(266, 291);
}

function slideInfoPanel(animation, current, start, finish)
{
	o('info_panel').style.left = parseInt(current) + 'px';
}

// Standard Apple widget-flipping functions
function showPrefs()
{
    var front = o("front");
    var back = o("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
    var front = o("front");
    var back = o("back");

	getAsins();

    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

// Generate drop-down list of subcategories based on selected category
function loadSubcategories()
{
	var key    = o('category').value;
	var result = '';
	
	if (key)
	{
		var subcats = categories[key];
		for (var i = 0; i < subcats.length; i++)
		{
			result = result + '<option value="' + subcats[i][1] + '">' + subcats[i][0] + '</option>';
		}
	}
	o('subcategory').innerHTML = result;
}


function populateCategoriesArray()
{
	categories = new Array();
	categories["Baby"] = new Array();
	categories["Baby"].push(new Array("Activity", 542460));
	categories["Baby"].push(new Array("Bath &amp; Potty", 541586));
	categories["Baby"].push(new Array("Feeding", 541564));
	categories["Baby"].push(new Array("For Moms", 764538));
	categories["Baby"].push(new Array("Gear", 541558));
	categories["Baby"].push(new Array("Health &amp; Safety", 541580));
	categories["Baby"].push(new Array("Layette", 738468));
	categories["Baby"].push(new Array("Nursery", 541572));
	categories["Books"] = new Array();
	categories["Books"].push(new Array("Arts &amp; Photography", 1));
	categories["Books"].push(new Array("Biographies &amp; Memoirs", 2));
	categories["Books"].push(new Array("Business &amp; Investing", 3));
	categories["Books"].push(new Array("Children's Books", 4));
	categories["Books"].push(new Array("Comics &amp; Graphic Novels", 4366));
	categories["Books"].push(new Array("Computers &amp; Internet", 5));
	categories["Books"].push(new Array("Cooking, Food &amp; Wine", 6));
	categories["Books"].push(new Array("Engineering", 13643));
	categories["Books"].push(new Array("Entertainment", 86));
	categories["Books"].push(new Array("Gay &amp; Lesbian", 301889));
	categories["Books"].push(new Array("Health, Mind &amp; Body", 10));
	categories["Books"].push(new Array("History", 9));
	categories["Books"].push(new Array("Home &amp; Garden", 48));
	categories["Books"].push(new Array("Horror", 49));
	categories["Books"].push(new Array("Law", 10777));
	categories["Books"].push(new Array("Literature &amp; Fiction", 17));
	categories["Books"].push(new Array("Medicine", 13996));
	categories["Books"].push(new Array("Mystery &amp; Thrillers", 18));
	categories["Books"].push(new Array("Nonfiction", 53));
	categories["Books"].push(new Array("Outdoors &amp; Nature", 290060));
	categories["Books"].push(new Array("Parenting &amp; Families", 20));
	categories["Books"].push(new Array("Professional &amp; Technical", 173507));
	categories["Books"].push(new Array("Reference", 21));
	categories["Books"].push(new Array("Religion &amp; Spirituality", 22));
	categories["Books"].push(new Array("Romance", 23));
	categories["Books"].push(new Array("Science", 75));
	categories["Books"].push(new Array("Science Fiction &amp; Fantasy", 25));
	categories["Books"].push(new Array("Sports", 26));
	categories["Books"].push(new Array("Teens", 28));
	categories["Books"].push(new Array("Travel", 27));
	categories["Classical"] = new Array();
	categories["Classical"].push(new Array("Ballets &amp; Dances", 5260));
	categories["Classical"].push(new Array("Chamber Music", 5318));
	categories["Classical"].push(new Array("Featured Composers, A-Z", 5338));
	categories["Classical"].push(new Array("Featured Performers, A-Z", 38472));
	categories["Classical"].push(new Array("Forms &amp; Genres", 36632));
	categories["Classical"].push(new Array("General", 300358));
	categories["Classical"].push(new Array("Historical Periods", 36712));
	categories["Classical"].push(new Array("Index", 573448));
	categories["Classical"].push(new Array("Instruments", 38374));
	categories["Classical"].push(new Array("Sacred &amp; Religious", 63654));
	categories["Classical"].push(new Array("Symphonies", 63681));
	categories["DVD"] = new Array();
	categories["DVD"].push(new Array("Action &amp; Adventure", 163296));
	categories["DVD"].push(new Array("African American Cinema", 538708));
	categories["DVD"].push(new Array("Animation", 712256));
	categories["DVD"].push(new Array("Anime &amp; Manga", 517956));
	categories["DVD"].push(new Array("Art House &amp; International", 163313));
	categories["DVD"].push(new Array("Classics", 163345));
	categories["DVD"].push(new Array("Comedy", 163357));
	categories["DVD"].push(new Array("Cult Movies", 466674));
	categories["DVD"].push(new Array("Documentary", 508532));
	categories["DVD"].push(new Array("Drama", 163379));
	categories["DVD"].push(new Array("Educational", 290738));
	categories["DVD"].push(new Array("Fitness &amp; Yoga", 578324));
	categories["DVD"].push(new Array("Gay &amp; Lesbian", 301667));
	categories["DVD"].push(new Array("Horror", 163396));
	categories["DVD"].push(new Array("Kids &amp; Family", 163414));
	categories["DVD"].push(new Array("Military &amp; War", 586156));
	categories["DVD"].push(new Array("Music Video &amp; Concerts", 163420));
	categories["DVD"].push(new Array("Musicals &amp; Performing Arts", 508528));
	categories["DVD"].push(new Array("Mystery &amp; Suspense", 512030));
	categories["DVD"].push(new Array("Science Fiction &amp; Fantasy", 163431));
	categories["DVD"].push(new Array("Special Interests", 163448));
	categories["DVD"].push(new Array("Sports", 467970));
	categories["DVD"].push(new Array("Television", 163450));
	categories["DVD"].push(new Array("Westerns", 163312));
	categories["Electronics"] = new Array();
	categories["Electronics"].push(new Array("Accessories &amp; Supplies", 281407));
	categories["Electronics"].push(new Array("Audio &amp; Video", 1065836));
	categories["Electronics"].push(new Array("Car Electronics", 1077068));
	categories["Electronics"].push(new Array("Clocks &amp; Clock Radios", 509280));
	categories["Electronics"].push(new Array("Computer Add-Ons", 172455));
	categories["Electronics"].push(new Array("Electronic Watches", 1199074));
	categories["Electronics"].push(new Array("Flashlights", 11038771));
	categories["Electronics"].push(new Array("Gadgets", 172517));
	categories["Electronics"].push(new Array("GPS &amp; Navigation", 172526));
	categories["Electronics"].push(new Array("Handhelds &amp; PDAs", 172594));
	categories["Electronics"].push(new Array("Home Automation &amp; Security", 11040111));
	categories["Electronics"].push(new Array("Office Electronics", 172574));
	categories["Electronics"].push(new Array("Printers", 172635));
	categories["Electronics"].push(new Array("Telephones", 172606));
	categories["Kitchen"] = new Array();
	categories["Kitchen"].push(new Array("Baking", 289668));
	categories["Kitchen"].push(new Array("Bar Tools &amp; Glasses", 289728));
	categories["Kitchen"].push(new Array("Coffee, Tea &amp; Espresso", 289742));
	categories["Kitchen"].push(new Array("Cook's Tools &amp; Gadgets", 289754));
	categories["Kitchen"].push(new Array("Cookbooks", 554616));
	categories["Kitchen"].push(new Array("Cookware", 289814));
	categories["Kitchen"].push(new Array("Cutlery", 289851));
	categories["Kitchen"].push(new Array("Housewares", 510080));
	categories["Kitchen"].push(new Array("Kitchen Linens", 1063916));
	categories["Kitchen"].push(new Array("Kitchen Plumbing Fixtures &amp; Sinks", 3742041));
	categories["Kitchen"].push(new Array("Large Appliances", 3741171));
	categories["Kitchen"].push(new Array("Small Appliances", 289913));
	categories["Kitchen"].push(new Array("Storage &amp; Organization", 3610841));
	categories["Kitchen"].push(new Array("Tableware", 289891));
	categories["Magazines"] = new Array();
	categories["Magazines"].push(new Array("Arts &amp; Crafts", 602314));
	categories["Magazines"].push(new Array("Automotive", 602316));
	categories["Magazines"].push(new Array("Bridal", 602318));
	categories["Magazines"].push(new Array("Business &amp; Finance", 602320));
	categories["Magazines"].push(new Array("Children's", 602322));
	categories["Magazines"].push(new Array("Computer &amp; Internet", 602324));
	categories["Magazines"].push(new Array("Electronics &amp; Audio", 602326));
	categories["Magazines"].push(new Array("Entertainment", 602328));
	categories["Magazines"].push(new Array("Family &amp; Parenting", 602330));
	categories["Magazines"].push(new Array("Fashion &amp; Style", 602332));
	categories["Magazines"].push(new Array("Food &amp; Gourmet", 602334));
	categories["Magazines"].push(new Array("Games &amp; Hobbies", 602336));
	categories["Magazines"].push(new Array("Gay &amp; Lesbian", 602338));
	categories["Magazines"].push(new Array("Health &amp; Fitness", 602340));
	categories["Magazines"].push(new Array("History", 602342));
	categories["Magazines"].push(new Array("Home &amp; Garden", 602344));
	categories["Magazines"].push(new Array("International", 602346));
	categories["Magazines"].push(new Array("Lifestyle &amp; Cultures", 602348));
	categories["Magazines"].push(new Array("Literary", 602350));
	categories["Magazines"].push(new Array("Men's Interest", 602352));
	categories["Magazines"].push(new Array("Music", 602354));
	categories["Magazines"].push(new Array("News &amp; Politics", 602358));
	categories["Magazines"].push(new Array("Newspapers", 1040160));
	categories["Magazines"].push(new Array("Pets", 602360));
	categories["Magazines"].push(new Array("Professional &amp; Trade", 1115660));
	categories["Magazines"].push(new Array("Religion &amp; Spirituality", 602362));
	categories["Magazines"].push(new Array("Science &amp; Nature", 602364));
	categories["Magazines"].push(new Array("Spanish-Language", 1040158));
	categories["Magazines"].push(new Array("Sports &amp; Leisure", 602366));
	categories["Magazines"].push(new Array("Teens", 602368));
	categories["Magazines"].push(new Array("Travel &amp; Regional", 602370));
	categories["Magazines"].push(new Array("Women's Interest", 602372));
	categories["Music"] = new Array();
	categories["Music"].push(new Array("Alternative Rock", 30));
	categories["Music"].push(new Array("Blues", 31));
	categories["Music"].push(new Array("Broadway &amp; Vocalists", 265640));
	categories["Music"].push(new Array("Children's Music", 173425));
	categories["Music"].push(new Array("Christian &amp; Gospel", 173429));
	categories["Music"].push(new Array("Classic Rock", 67204));
	categories["Music"].push(new Array("Classical", 85));
	categories["Music"].push(new Array("Country", 16));
	categories["Music"].push(new Array("Dance &amp; DJ", 7));
	categories["Music"].push(new Array("Folk", 32));
	categories["Music"].push(new Array("Hard Rock &amp; Metal", 67207));
	categories["Music"].push(new Array("International", 33));
	categories["Music"].push(new Array("Jazz", 34));
	categories["Music"].push(new Array("Latin Music", 289122));
	categories["Music"].push(new Array("Miscellaneous", 35));
	categories["Music"].push(new Array("New Age", 36));
	categories["Music"].push(new Array("Opera &amp; Vocal", 84));
	categories["Music"].push(new Array("Pop", 37));
	categories["Music"].push(new Array("R&amp;B", 39));
	categories["Music"].push(new Array("Rap &amp; Hip-Hop", 38));
	categories["Music"].push(new Array("Rock", 40));
	categories["Music"].push(new Array("Soundtracks", 42));
	categories["Office Products"] = new Array();
	categories["Office Products"].push(new Array("Business Presentation Supplies", 1069254));
	categories["Office Products"].push(new Array("Cleaning &amp; Maintenance", 1068798));
	categories["Office Products"].push(new Array("Furniture &amp; Accessories", 1069102));
	categories["Office Products"].push(new Array("Lighting", 1068956));
	categories["Office Products"].push(new Array("Lunchroom Supplies", 1068716));
	categories["Office Products"].push(new Array("Mailroom Supplies", 1068972));
	categories["Office Products"].push(new Array("Office Supplies", 1069242));
	categories["Office Products"].push(new Array("Safety &amp; First Aid", 1068778));
	categories["Office Products"].push(new Array("Teaching Materials", 1068990));
	categories["Outdoor Living"] = new Array();
	categories["Outdoor Living"].push(new Array("Gardening Tools", 10925081));
	categories["Outdoor Living"].push(new Array("Gifts", 553648));
	categories["Outdoor Living"].push(new Array("Grills, Fryers &amp; Outdoor Cooking", 553760));
	categories["Outdoor Living"].push(new Array("Heating &amp; Lighting", 553778));
	categories["Outdoor Living"].push(new Array("Lawn &amp; Garden Tools", 915192));
	categories["Outdoor Living"].push(new Array("Leisure &amp; Fitness", 1063918));
	categories["Outdoor Living"].push(new Array("Outdoor Decor", 553788));
	categories["Outdoor Living"].push(new Array("Patio Furniture", 553824));
	categories["Outdoor Living"].push(new Array("Pest Control", 553844));
	categories["Outdoor Living"].push(new Array("Plants, Seeds &amp; Flowers", 3610851));
	categories["PC Hardware"] = new Array();
	categories["PC Hardware"].push(new Array("Desktops", 565098));
	categories["PC Hardware"].push(new Array("Notebooks", 565108));
	categories["PC Hardware"].push(new Array("Servers", 11036071));
	categories["Pet Supplies"] = new Array();
	categories["Pet Supplies"].push(new Array("Aquatic Pets", 12923381));
	categories["Pet Supplies"].push(new Array("Birds", 12923981));
	categories["Pet Supplies"].push(new Array("Cats", 12924061));
	categories["Pet Supplies"].push(new Array("Dogs", 12925321));
	categories["Pet Supplies"].push(new Array("Insects &amp; Spiders", 12926701));
	categories["Pet Supplies"].push(new Array("Other Pets", 12937551));
	categories["Pet Supplies"].push(new Array("Reptiles &amp; Amphibians", 12926711));
	categories["Pet Supplies"].push(new Array("Small Animals", 12927351));
	categories["Photo"] = new Array();
	categories["Photo"].push(new Array("Accessories", 172435));
	categories["Photo"].push(new Array("Camcorders", 172421));
	categories["Photo"].push(new Array("Digital Cameras", 281052));
	categories["Photo"].push(new Array("Film Cameras", 499106));
	categories["Photo"].push(new Array("Graphics Software", 554886));
	categories["Photo"].push(new Array("Optics", 499320));
	categories["Photo"].push(new Array("Photography Books", 554888));
	categories["Photo"].push(new Array("Printers &amp; Scanners", 499328));
	categories["Photo"].push(new Array("Projectors", 525462));
	categories["Photo"].push(new Array("Surveillance Systems", 524136));
	categories["Restaurants"] = new Array();
	categories["Restaurants"].push(new Array("African (Other)", 1002938));
	categories["Restaurants"].push(new Array("American", 1002940));
	categories["Restaurants"].push(new Array("American Regional", 1002942));
	categories["Restaurants"].push(new Array("Asian (Other)", 1002944));
	categories["Restaurants"].push(new Array("Bakery", 1002946));
	categories["Restaurants"].push(new Array("Bar &amp; Pub", 1002948));
	categories["Restaurants"].push(new Array("Cajun &amp; Creole", 1002950));
	categories["Restaurants"].push(new Array("Caribbean", 1002952));
	categories["Restaurants"].push(new Array("Chinese", 1002954));
	categories["Restaurants"].push(new Array("Coffee &amp; Tea Houses", 1002956));
	categories["Restaurants"].push(new Array("Cuban", 1002958));
	categories["Restaurants"].push(new Array("Deli", 1002960));
	categories["Restaurants"].push(new Array("Dessert", 1002962));
	categories["Restaurants"].push(new Array("Eastern European", 1002964));
	categories["Restaurants"].push(new Array("Ethiopian", 1002966));
	categories["Restaurants"].push(new Array("European (Other)", 1002968));
	categories["Restaurants"].push(new Array("French", 1002970));
	categories["Restaurants"].push(new Array("Fusion", 1002972));
	categories["Restaurants"].push(new Array("German", 1002974));
	categories["Restaurants"].push(new Array("Greek", 1002976));
	categories["Restaurants"].push(new Array("Indian", 1002978));
	categories["Restaurants"].push(new Array("Irish", 1002980));
	categories["Restaurants"].push(new Array("Italian", 1002982));
	categories["Restaurants"].push(new Array("Japanese", 1002984));
	categories["Restaurants"].push(new Array("Korean", 1002986));
	categories["Restaurants"].push(new Array("Latin American", 1002988));
	categories["Restaurants"].push(new Array("Lebanese", 1002990));
	categories["Restaurants"].push(new Array("Malaysian", 1002992));
	categories["Restaurants"].push(new Array("Mediterranean", 1002994));
	categories["Restaurants"].push(new Array("Mexican", 1002996));
	categories["Restaurants"].push(new Array("Middle Eastern", 1002998));
	categories["Restaurants"].push(new Array("Moroccan", 1003000));
	categories["Restaurants"].push(new Array("New American", 1003002));
	categories["Restaurants"].push(new Array("New Latin", 1003004));
	categories["Restaurants"].push(new Array("Other Cuisines", 1003006));
	categories["Restaurants"].push(new Array("Pan-Asian", 1003008));
	categories["Restaurants"].push(new Array("Pizza", 1003010));
	categories["Restaurants"].push(new Array("Seafood", 1003012));
	categories["Restaurants"].push(new Array("South American", 1003014));
	categories["Restaurants"].push(new Array("Spanish", 1003016));
	categories["Restaurants"].push(new Array("Steak House", 1003018));
	categories["Restaurants"].push(new Array("Thai", 1003020));
	categories["Restaurants"].push(new Array("Turkish", 1003022));
	categories["Restaurants"].push(new Array("Vegetarian &amp; Health Food", 1003024));
	categories["Restaurants"].push(new Array("Vietnamese", 1003026));
	categories["Software"] = new Array();
	categories["Software"].push(new Array("Business &amp; Office", 229535));
	categories["Software"].push(new Array("Business &amp; Office Management Software", 283891));
	categories["Software"].push(new Array("Children's Software", 229548));
	categories["Software"].push(new Array("Education &amp; Reference", 229563));
	categories["Software"].push(new Array("Graphics", 229614));
	categories["Software"].push(new Array("Home &amp; Hobbies", 229624));
	categories["Software"].push(new Array("Language &amp; Travel", 497026));
	categories["Software"].push(new Array("Linux", 290562));
	categories["Software"].push(new Array("Macintosh", 229643));
	categories["Software"].push(new Array("Networking", 229637));
	categories["Software"].push(new Array("Operating Systems", 229653));
	categories["Software"].push(new Array("Personal Finance", 229540));
	categories["Software"].push(new Array("Programming", 229667));
	categories["Software"].push(new Array("Software Downloads", 531448));
	categories["Software"].push(new Array("Software for Handhelds", 229663));
	categories["Software"].push(new Array("Utilities", 229672));
	categories["Software"].push(new Array("Video &amp; Music", 497022));
	categories["Software"].push(new Array("Web Development", 497024));
	categories["Sporting Goods"] = new Array();
	categories["Sporting Goods"].push(new Array("Sports Equipment", 3395101));
	categories["Sporting Goods"].push(new Array("Accessories", 339481));
	categories["Sporting Goods"].push(new Array("Fan Shop", 3386071));
	categories["Sporting Goods"].push(new Array("Apparel", 3375311));
	categories["Sporting Goods"].push(new Array("Footwear", 3392741));
	categories["Sporting Goods"].push(new Array("Sports Medicine", 3422351));
	categories["Tools"] = new Array();
	categories["Tools"].push(new Array("Agricultural &amp; Excavating Tools", 3753961));
	categories["Tools"].push(new Array("Automotive", 553294));
	categories["Tools"].push(new Array("Collectibles &amp; Toy Models", 923468));
	categories["Tools"].push(new Array("Electrical", 495266));
	categories["Tools"].push(new Array("Hand Tools", 551238));
	categories["Tools"].push(new Array("Hardware", 511228));
	categories["Tools"].push(new Array("Heating &amp; Cooling", 495346));
	categories["Tools"].push(new Array("Hydraulics", 3754081));
	categories["Tools"].push(new Array("Job Site Equipment", 551240));
	categories["Tools"].push(new Array("Lawn &amp; Landscaping", 551242));
	categories["Tools"].push(new Array("Lighting", 495224));
	categories["Tools"].push(new Array("Plumbing Fixtures &amp; Faucets", 3754161));
	categories["Tools"].push(new Array("Power Tools", 551236));
	categories["Tools"].push(new Array("Safety &amp; Security", 3180231));
	categories["Toys"] = new Array();
	categories["Toys"].push(new Array("Action Figures", 171662));
	categories["Toys"].push(new Array("Activities &amp; Learning", 171911));
	categories["Toys"].push(new Array("Arts &amp; Crafts", 171859));
	categories["Toys"].push(new Array("Bikes, Scooters &amp; More", 569472));
	categories["Toys"].push(new Array("Building Sets, Blocks &amp; Models", 171814));
	categories["Toys"].push(new Array("Dolls", 171569));
	categories["Toys"].push(new Array("Electronics", 720366));
	categories["Toys"].push(new Array("Furniture for Kids", 172790));
	categories["Toys"].push(new Array("Games", 171689));
	categories["Toys"].push(new Array("Kids' Video Games", 554996));
	categories["Toys"].push(new Array("Puzzles", 171744));
	categories["Toys"].push(new Array("Sports &amp; Outdoor Play", 171960));
	categories["Toys"].push(new Array("Stuffed Animals", 171992));
	categories["Toys"].push(new Array("Vehicles &amp; Die-Cast", 171600));
	categories["VHS"] = new Array();
	categories["VHS"].push(new Array("Action &amp; Adventure", 141));
	categories["VHS"].push(new Array("African American Cinema", 301597));
	categories["VHS"].push(new Array("Animation", 712260));
	categories["VHS"].push(new Array("Anime &amp; Manga", 281300));
	categories["VHS"].push(new Array("Art House &amp; International", 126));
	categories["VHS"].push(new Array("Classics", 127));
	categories["VHS"].push(new Array("Comedy", 128));
	categories["VHS"].push(new Array("Cult Movies", 162482));
	categories["VHS"].push(new Array("Documentary", 508530));
	categories["VHS"].push(new Array("Drama", 129));
	categories["VHS"].push(new Array("Educational", 290220));
	categories["VHS"].push(new Array("Fitness", 169660));
	categories["VHS"].push(new Array("Gay &amp; Lesbian", 301665));
	categories["VHS"].push(new Array("Horror", 131));
	categories["VHS"].push(new Array("Kids &amp; Family", 132));
	categories["VHS"].push(new Array("Military &amp; War", 586154));
	categories["VHS"].push(new Array("Music Video &amp; Concerts", 133));
	categories["VHS"].push(new Array("Musicals &amp; Performing Arts", 508526));
	categories["VHS"].push(new Array("Mystery &amp; Suspense", 512026));
	categories["VHS"].push(new Array("Science Fiction &amp; Fantasy", 144));
	categories["VHS"].push(new Array("Special Interests", 135));
	categories["VHS"].push(new Array("Sports", 169798));
	categories["VHS"].push(new Array("Television", 136));
	categories["VHS"].push(new Array("Westerns", 139725));
	categories["Video Games"] = new Array();
	categories["Video Games"].push(new Array("Game Boy Advance", 541020));
	categories["Video Games"].push(new Array("GameCube", 541022));
	categories["Video Games"].push(new Array("Mac Games", 229647));
	categories["Video Games"].push(new Array("More Systems", 294940));
	categories["Video Games"].push(new Array("Nintendo DS", 11075831));
	categories["Video Games"].push(new Array("Nokia N-Gage", 10986441));
	categories["Video Games"].push(new Array("PC Games", 229575));
	categories["Video Games"].push(new Array("PDAs", 10986071));
	categories["Video Games"].push(new Array("PlayStation", 229773));
	categories["Video Games"].push(new Array("PlayStation2", 301712));
	categories["Video Games"].push(new Array("Sony PSP", 11075221));
	categories["Video Games"].push(new Array("Xbox", 537504));
	categories["Wireless"] = new Array();
	categories["Wireless"].push(new Array("Accessories", 301188));
	categories["Wireless"].push(new Array("Phones", 301187));
	categories["Wireless"].push(new Array("Service Plans", 301186));
}

// Website launch functions
function goAmazon(asin)
{
	var url = "http://www.amazon.com/exec/obidos/redirect?link_code=as2&path=ASIN/" + asin + "&tag=widget-20&camp=1789&creative=9325";
	
	if (window.widget)
		widget.openURL(url);
	else
		location.href = url;
}

function goWebsite()
{
	widget.openURL("http://www.widget-foundry.com/");
}

function goPaypal()
{
	widget.openURL("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=simon%40widget-foundry%2ecom&item_name=What's%20New%20At%20Amazon.com%20widget&amount=5%2e00&no_shipping=0&no_note=1&tax=0&currency_code=GBP&lc=GB&bn=PP%2dDonationsBF&charset=UTF%2d8");
}

// version function courtesy of Joshua Emmons (www.skia.net)
function version()
{
    var xmlReq	= new XMLHttpRequest();
    xmlReq.open("GET", "Info.plist", false);
    xmlReq.send(null);

    var xml		= xmlReq.responseXML;
    var keys	= xml.getElementsByTagName("key");
    var ver		= "0.0";

    for(i = 0; i < keys.length; i++)
    {
		if("CFBundleVersion" == keys[i].firstChild.data)
		{
	    	ver = keys[i].nextSibling.nextSibling.firstChild.data;
	    	break;
		}
    }
    return ver;
}

// DOM Object caching function
function o(x) 
{ 
	if ( !gDOMObjs[x] ) 
		gDOMObjs[x] = document.getElementById(x); 
	return gDOMObjs[x]; 
}